Packages - Freedom Issue #1631

[intellij-idea-community-edition] Parts of the package are under different licenses than Apache, some
nonfree - PKGBUILD is not built from source

2018-02-08 08:45 AM - asie

Status: fixed % Done: 100%
Priority: freedom issue

Assignee: bill-auger

Category:

Description

While IntelliJ IDEA Community Edition is commonly listed as Apache 2.0-licensed, that license only applies to the parts of the code
provided by JetBrains - that is, the editor itself and not necessarily the libraries it utilizes, or the libraries utilized by its plugins.

The following evaluates the state of the licensing as documented by JetBrains themselves - I'll get to why that is important a bit later:

°

XStream: 3-clause BSD, free software

¢ Apache Ant: Apache 2.0, free software

e ASM: 3-clause BSD, free software

e Growl: 3-clause BSD, free software

e GSON: Apache 2.0, free software

e ImgScalr: Apache 2.0, free software

¢ JavaHelp: Binary Code License Agreement, non-free

e Javolution: 2-clause BSD, free software

e JAXB: CDDL v1.1, free software (GPL-incompatible)

e Jaxen: 3-clause BSD, free software

e Jayatana: X11 license, free software

* JDOM: 3-clause BSD with one additional clause: "Products derived from this software may not be called "JDOM", nor may
"JDOM" appear in their name, without prior written permission” (also includes a clause similar to the Original BSD License's
advertising clause but unlike said license, it is not compulsory), | think that qualifies as free software? I'm not sure.
JUnit: Common Public License 0.5, ??? (I don't know)

Kryo: 3-clause BSD, free software

Log4j: Apache 1.1, free software (GPL-incompatible)

Microba: 3-clause BSD, free software

MiGLayout Swing: 3-clause BSD, free software

NanoXML.: zlib license, free software

OROMatcher: non-free

picoContainer: 3-clause BSD, free software

SAXON: Mozilla Public License 1.0 + custom license for AElfred, ???

SQLJet: non-free (may only be freely distributed as part of the IntelliJ Platform, among other restrictions)
SVNK:it: non-free (see above)

SwingX: LGPLv2.1, free software

Trove4j: LGPLv2.1+ (plus custom license for two classes), free software

WinP: MIT, free software

Xerces: Apache 2.0, free software

XMLRPC: Apache 2.0, free software

YourKit: 3-clause BSD only for binary files, effectively non-free

There are also broader license files which do not refer to any particular file:

¢ eclipse_license.txt: Eclipse Public License v1.0, free software (not GPL-compatible)
¢ eclipse_license2.txt: Eclipse Public License v2.0, free software (not automatically GPL-compatible)

However, upon closer examination, it appears IntelliJ includes multiple libraries not listed in licenses/, as well as libraries with
licenses different than what is listed in licenses/. In other words, the list of licenses in there is best ignored, removed and recreated
based on what the bundled libraries themselves represent. Thus, using the above list as a guide only, we arrive at the following list:

lib/ (mandatory-by-default components):
¢ MultithreadedTC: 3-clause BSD, free software
e Aether: Apache 2.0, free software

¢ Apache Ant: Apache 2.0, free software
e ASM: 3-clause BSD, free software
Automaton: 2-clause BSD (http://www.brics.dk/automaton/), free software

Batik: Apache 2.0 (+ CC BY-SA 2.5 for icons), free software

Bouncy Castle Crypto: X11 license, free software

CGLib: Apache 2.0, free software

cli-parser: Apache 2.0 (https://github.com/spullara/cli-parser), free software

Common (TwelveMonkeys): 3-clause BSD (https:/github.com/haraldk/TwelveMonkeys/blob/master/LICENSE.txt), free software
Commons (Apache): Apache 2.0, free software

Cucumber Core: X11 license, free software

Cucumber Groovy: no license, non-free (although | am going to assume that was not the intention, issue open here:
https://github.com/cucumber/cucumber-jvm-groovy/issues/4 )

ECJ (Eclipse): Eclipse Public License v1.0, free software (not GPL-compatible)

Emma: Common Public License 1.0 (http:/emma.sourceforge.net/license.html), free software (not GPL-compatible)

Fest libraries: Apache 2.0 (https://github.com/alexruiz/fest-swing-1.x/blob/master/fest-swing/LICENSE.txt), free software
fluent-hc (Apache): Apache 2.0, free software

Gherkin: X11 license (https:/github.com/cucumber/gherkin-java/blob/master/LICENSE), free software (bundles GSON, see
below)

Google Analytics Library: Apache 2.0 (
https://android.googlesource.com/platform/tools/analytics-library/+/gradle_3.0.0/shared/NOTICE), free software.

Groovy: Apache 2.0, free software

Growl: 3-clause BSD, free software

GSON: Apache 2.0, free software

Guava: Apache 2.0, free software

Hamcrest: 3-clause BSD, free software

Apache HTTP libraries: Apache 2.0, free software

ImagelO (TwelveMonkeys): 3-clause BSD (https://github.com/haraldk/TwelveMonkeys/blob/master/LICENSE..txt), free software
ImgScalr: Apache 2.0, free software

Ini4j: Apache 2.0 (http:/ini4j.sourceforge.net/license.html, but this version is actually used:
https:/github.com/JetBrains/intellij-deps-ini4j/blob/master/LICENSE.txt), free software

isorelax: X11 license, free software

Jaxen: 3-clause BSD, free software

Jayatana: X11 license, free software

JCIP Annotations: CC BY-SA 2.5. While it is a bit of an ugly license for code, if that's a problem
https://github.com/stephenc/jcip-annotations provides a claimed-to-be-cleanroomed implementation under Apache 2.0 instead.
JDOM: 3-clause BSD with one additional clause: "Products derived from this software may not be called "JDOM", nor may
"JDOM" appear in their name, without prior written permission” (also includes a clause similar to the Original BSD License's
advertising clause but unlike said license, it is not compulsory), | think that qualifies as free software? I'm not sure.

¢ Jediterm: Apache 2.0 and LGPLV3, free software (https://github.com/JetBrains/jediterm)

JGoodies: the older versions JetBrains bundles are claimed by JetBrains to be 3-clause BSD-licensed; unfortunately, the
author's archive does not go that far and newest versions of this library are proprietary. However, some internet research (
http://web.archive.org/web/20111107063221/http://www.jgoodies.com/downloads/libraries.html) lets us find out that the code is
actually licensed under 2-clause BSD, which is, indeed, free software.

JavaHelp: the release JetBrains bundles, 2.0_02, is non-free under the Binary Code License Agreement.

Jimfs: Apache 2.0 (https://github.com/google/jimfs/blob/master/LICENSE), free software

Jing, Trang: 3-clause BSD (http://www.thaiopensource.com/relaxng/copying.html), free software

JNA: LGPLv2.1, free software

JCraft JSCH: 3-clause BSD (http://www.jcraft.com/jsch/LICENSE.txt), free software

jsr173_1.0_api.jar: no information could be found, I'm going to assume non-free

jsr305.jar: 3-clause BSD (https://code.google.com/archive/p/jsr-305/), free software

JUnit: Eclipse Public License 1.0, free software (GPL-incompatible)

Kotlin: Apache 2.0 (https://github.com/JetBrains/kotlin/blob/master/license/LICENSE.txt), free software

Kryo: 3-clause BSD, free software

Log4j: Apache 2.0, free software

Markdown4j: 3-clause BSD (https:/code.google.com/archive/p/markdownd4j/), free software

Markdownd: 3-clause BSD (https://github.com/myabc/markdownj/blob/master/LICENSE), free software

Microba: 3-clause BSD, free software

MiGLayout Swing: 3-clause BSD, free software

NanoXML.: zlib license, free software

NekoHTML: Apache 2.0, free software

Netty: Apache 2.0, free software

OROMatcher: Apache 1.1, free software (GPL-incompatible)

picoContainer: 3-clause BSD, free software

ProtoBuf: 3-clause BSD (https:/github.com/google/protobuf/blob/master/LICENSE), free software

proxy-vole-1.0.3.jar: Apache 2.0, free software

pty4j: Eclipse Public License 1.0 (https:/github.com/traff/pty4j/blob/master/LICENSE), free software (GPL-incompatible)
purejavacomm: 3-clause BSD (https:/github.com/nyholku/purejavacomm/blob/master/LICENSE.md), free software
rngom: X11 license (https:/github.com/kohsuke/rngom/blob/master/licenceheader.txt + JetBrains' own claim), free software
SLF4J: X11 license (https://www.slf4j.org/license.html), free software
SnakeYAML: Apache 2.0 (https:/github.com mov/snakeyaml/blob/m r/LICENSE.txt), free software
Snappy-in-Java: Apache 2.0 (https://github.com/dain/snappy/blob/master/license.txt), free software
sqlite-jdbc: Apache 2.0 + 2-clause BSD (https://github.com/xerial/sqlite-jdbc), free software

StreamEx: Apache 2.0 (https:/github.com/amaembo/streamex/blob/master/LICENSE), free software
studio-profiler-grpc: Apache 2.0 for both gRPC and Android components, free software

SwingX: LGPLv2.1, free software

Trilead SSH2: 3-clause BSD (https://github.com/jenkinsci/trilead-ssh2/blob/master/LICENSE.txt), free software
Trovedj: LGPLv2.1+ (plus custom license for two classes), free software

Apache Velocity: Apache 2.0, free software

WADL: unknown, going to assume non-free for reasons outlined later

WinP: MIT, free software

Xerces: Apache 2.0, free software

XMLBeans: Apache 2.0, free software

XMLRPC: Apache 2.0, free software

XStream: 3-clause BSD, free software

Now, it's time to evaluate the plugins. There's a lot of plugins to go through:

e ByteCodeViewer, Groovy, IntelliLang, ant, copyright, eclipse, editorconfig, gitdidea, github, hg4idea, java-i18n, junit, properties,
stream-debugger, terminal, uiDesigner, xpath, xslt-debugger, yaml: do not bundle non-JetBrains dependencies, are Apache
2.0-licensed and are thus free software

Kotlin:
¢ javaslang: Apache 2.0, free software

¢ javax.inject: Apache 2.0 (http:/code.google.com/p/atinject/), free software
e Kotlin: Apache 2.0 (https://github.com/JetBrains/kotlin/blob/master/license/LICENSE.txt), free software

android:

Android components: Apache 2.0 (AOSP), free software

ANTLR: BSD 3-clause (http://www.antlr.org/license.html), free software

ASM, BouncyCastle, Apache components: as in lib/, free software

dexlib2: Apache 2.0/BSD 3-clause (https://github.com/JesusFreke/smali), free software

FreeMarker: BSD 3-clause with "Products derived may not be called" addition (similar to JDOM), free software?
JavaWriter (Square): Apache 2.0 (http:/github.com/square/javawriter), free software

JGraphX: 3-clause BSD (https://github.com/jgraph/jgraphx), free software

JOGL: 2-clause BSD (https:/github.com/sgothel/jogl/blob/master/LICENSE.txt), free software
juniversalchardet: MPL 1.1 (https://github.com/albfernandez/juniversalchardet/blob/master/MPL-1.1.txt), free software
(GPL-incompatible)

kxml2: X11 license (https:/github.com/stefanhaustein/kxml2/blob/master/license.xt), free software

libwebp: 3-clause BSD, free software (seems to be in Parabola under one of its other implementations)

Lombok AST: X11 license, free software

spantable: LGPLv2.1+, free software

coverage:

¢ FreeMarker: BSD 3-clause with "Products derived may not be called" addition (similar to JDOM), free software?
¢ JaCoCo: Eclipse Public License 1.0 (http://www.jacoco.org/jacoco/trunk/doc/license.html), free software (GPL-incompatible)

cvsintegration:

¢ JavaCVS: Sun Public License, free software (GPL-incompatible)

e smartcvs-src: | genuinely have no idea. The only reference | can find to those classes is in Intellid's own source tree, but the files
themselves have no license headers. Unknown status.

e Trilead SSH2: 3-clause BSD (https://github.com/jenkinsci/trilead-ssh2/blob/master/LICENSE.txt), free software

devkit:

¢ DTDParser: LGPL (which version is this? -
http://web.archive.org/web/20010208195026/http://wutka.com:80/dtdparserlicense.html), free software

gradle:

e Apache Commons, Guava: as in lib/
e Gradle: Apache 2.0 (https:/github.com/gradle/gradle/blob/master/LICENSE), free software
e JAnsi: Apache 2.0 (https:/github.com/fusesource/jansi/blob/master/license.txt), free software
Kryo: 3-clause BSD, free software

Minlog: 3-clause BSD (https://github.com/EsotericSoftware/minlog/blob/master/license.ixt), free software
Objenesis: Apache 2.0 (http://objenesis.org/license.html), free software

ReflectASM: 3-clause BSD (https://github.com/EsotericSoftware/reflectasm/blob/master/license.txt), free software

java-decompiler: The decompiler itself is Apache 2.0, but it has to be evaluated whether or not the following EULA/disclaimer affects
the decision:
https://github.com/JetBrains/intellij-community/blob/master/plugins/java-decompiler/plugin/src/messages/Decompiler.properties

javaFX:

¢ SceneBuilderKit: 3-clause BSD (example:
https://bitbucket.org/gluon-oss/scenebuilder/src/ac28c033b85b7a0e2781bbcedb7{884d5b4771b1/kit/src/main/java/com/oracle/ja
vafx/scenebuilder/kit/ResourceUtils.java?at=default&fileviewer=file-view-default), free software

maven:
e Maven components, Plexus: Apache 2.0, free software
settings-repository:
e Jackson: Apache 2.0 (https:/github.com/FasterXML/jackson-core), free software

¢ JGit: Eclipse Distribution License 1.0, appears to just be 3-clause BSD (http://www.eclipse.org/org/documents/edl-v10.php), free
software?

svndidea:

¢ SQLJet: non-free (may only be freely distributed as part of the IntelliJ Platform, among other restrictions)
¢ SVNKit: non-free (see above)

Did not check other libraries as these two are sufficient for the plugin to be proprietary.
tasks:

e Apache Axis, Commons Discovery: Apache 2.0, free software

¢ json-path: Apache 2.0, free software

¢ json-smart: Apache 2.0, free software

¢ wsdl4j: Common Public License 1.0, free software (GPL-incompatible)

testng:

e JCommander: Apache 2.0 (https://github.com/cbeust/jcommander/blob/master/license.txt), free software
e TestNG: Apache 2.0, free software

This should cover the entirety of IntelliJ IDEA Community Edition, but | may have missed something somewhere. | think | haven't,
though.

Okay, so what libraries do not respect the user's freedom and what can be done about this?
Licensing issues
lib/:

e Cucumber Groovy: All we can do is wait for the developer to respond to the issue linked above. If the response does not arrive
or is unhelpful, an initial examination suggests it might be possible to remove the library with no damage to the software as a

whole.
e JavaHelp: A newer release can be compiled from https:/github.com/javaee/javahelp which is under the more tolerable CDDL
1.1 license.

e jsr173_1.0_api.jar: I'm fairly confident it can be rather easily removed, as Java 7 merged in a fairly similar API and this JAR in
particular should only be used by XMLBeans, not IDEA as a whole.

e WADL: Same as JavaHelp, a newer CDDL 1.1 release can be compiled from
https://github.com/javaee/wadl/blob/master/LICENSE .

plugins/:

e The cvslintegration and java-decompiler plugins require closer examination.
e The svndidea plugin must be removed entirely. (Can be achieved by just removing the directory)
Proprietary services

e Google Analytics Library: While it does not appear to be used for user tracking, it may be connected to the Android plugin.
Further evaluation required.
¢ GitHub plugin: Should anything be done about it?

Subtasks:

Freedom Issue # 1885: [intellij-idea-community-edition] Intellij IDEAD includes User Ag... not-a-bug
Freedom Issue # 3039: [intellij-idea-community-edition]: Issues with terms of use; plea... duplicate
History

#1 - 2018-02-08 10:43 AM - oaken-source

| wish all freedom issues on this tracker were as detailed as this one.

#2 - 2018-02-08 11:38 AM - asie

Further evaluation # 1:

e In regards to cvsintegration, the closest leads | could find are that the last time the file had a clear notice was ""/* * Copyright (c) $today.year
JetBrains s.r.o. All Rights Reserved. */""in one of its copyright generation files, as well as that SmartCVS is a proprietary CVS client written in
Java. | believe it is reasonable to consider this plugin non-free if/until JetBrains's upstream clarifies its licensing status.

e |t appears Intellid's buildscripts already contain a far more comprehensive list of bundled libraries and their licensing, in
/platform/build-scripts/groovy/org/jetbrains/intellij/build/CommunityLibraryLicenses.groovy, though | am not sure how comprehensive it is.
Importantly, it made me realize | have not checked licensing on most bundled non-JetBrains resources.

lib/resources.jar:

¢ I'm going to operate under the assumption JetBrains-created content in this file is under Apache 2.0, as is rest of the suite. This should be a

reasonable expectation, and mostly leaves fonts:
¢ Fonts: Fira Code, Inconsolata, Source Code Pro are all under the SIL Open Font License. Roboto is under the Apache 2.0 License instead. Both

seem to be fine.
Some additional notes, after searching for LICENSE/NOTICE files in the code source tree:

¢ The editorconfig plugin is actually X11-licensed.
¢ The hgdidea plugin bundles a standalone? Python script licensed under the GPLv2 (or later).

PyCharm has to be examined in the same manner - the differences shouldn't be very large, however, so | think it's better to tackle IDEA first and then
see how much PyCharm differs.

#3 - 2018-06-10 11:17 AM - nRoof

There are two more issues to that:

1. As has been mentioned in the Dev mailing list on Fri Jun 8 19:26:55 BST 2018, upon first start, IDEA shows "JETBRAINS USER AGREEMENT"
which clearly restricts user freedoms. But both the source code and the binary package contains Apache License Version 2.0 notice. So |
suspect it's either a bug, where it shows the agreement from the Ultimate edition, or an additional agreement for usage of JetBranins network
services, which may be non-free. All this needs additional investigation.

2. This package ships from Arch, and they just repackage binary files instead of building them from sources. The following ticket has been created
in their bug tracker to resolve the issue: https:/bugs.archlinux.org/index.php?do=details&task_id=58953

#4 - 2018-06-13 09:59 PM - bill-auger

quite an ostentatious stack of dependencies there

i gave it a try building this from source - the first thing ant does is download binary package of 'gradle’ and a pile of gradle plugins as java jars - then
binary packages for 'maven' and 'groovy' in order to build 'kotlin' - all of those programs are in parabola already so this is maybe not impossible but it
would be some work to get this to build without third-party blobs

the build went for some time then choked with this error:
[java] BUILD FAILED
[javal build/gant.xml:59: The following modules from
productProperties.productLayout.bundledPluginModules aren't found in the
project: [intellij.android.plugin, intellij.android.smali]
the PKGBUILD is in abslibre [libre-testing] - im washing my hands of this one - i say kick this beast to the curb :)
#5 - 2019-02-27 09:45 PM - bill-auger
- Priority changed from bug to freedom issue

- Status changed from open to confirmed
- Subject changed from [intellij-idea-community-edition] Parts of the package are under different licenses than Apache, some nonfree to
[intellij-idea-community-edition] Parts of the package are under different licenses than Apache, some nonfree - PKGBUILD is not built from source

#6 - 2021-05-25 08:29 AM - bill-auger

- Assignee set to bill-auger

#7 - 2021-05-25 08:29 AM - bill-auger

- Status changed from confirmed to fixed
